if (NOT FIND_GLUT_LOADED)

include (${CMAKE_SOURCE_DIR}/cmake/FindHelperMacros.cmake)

find_package (GLUT)

if (WIN32)
  set (GLUT_PREDEF_INCLUDE_PATHS ${OPENSG_DIR}/include/GL)
  FIND_INCLUDE_DIR_MACRO (Glut GLUT gl/glut.h GLUT_PREDEF_INCLUDE_PATHS EMPTY)

  set (GLUT_PREDEF_LIB_PATHS ${GLUT_INCLUDE_DIR} ${OPENSG_DIR}/lib)
  FIND_LIBRARY_MACRO (Glut GLUT glut32 GLUT_PREDEF_LIB_PATHS EMPTY)

elseif (APPLE AND ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set (GLUT_PREDEF_INCLUDE_PATHS /System/Library/Frameworks/GLUT.framework/Versions/A/Headers)
  FIND_INCLUDE_DIR_MACRO (Glut GLUT glut.h GLUT_PREDEF_INCLUDE_PATHS EMPTY)

  SET(GLUT_glut_LIBRARY "-framework GLUT" CACHE STRING "GLUT library for OSX")
  SET(GLUT_cocoa_LIBRARY "-framework Cocoa" CACHE STRING "Cocoa framework for OSX")

elseif (UNIX)
  set (GLUT_PREDEF_INCLUDE_SUFFIX GL)
  FIND_INCLUDE_DIR_MACRO (Glut GLUT GL/glut.h EMPTY GLUT_PREDEF_INCLUDE_SUFFIX)

  FIND_LIBRARY_MACRO (Glut GLUT glut EMPTY EMPTY)

else (WIN32)
  message (FATAL_ERROR "Unable to identify target operating system!")

endif (WIN32)

set (FIND_GLUT_LOADED ON)
endif (NOT FIND_GLUT_LOADED)

